力扣经典算法篇-26-长度最小的子数组(暴力求解法,左右指针法)

1、题干

给定一个含有n个正整数的数组和一个正整数target 。

找出该数组中满足其总和大于等于target的长度最小的子数组numsl, numsl+1, ..., numsr-1, numsr,并返回其长度。如果不存在符合条件的子数组,返回0 。

示例 1:

输入:target = 7, nums = 2,3,1,2,4,3

输出:2

解释:子数组 4,3 是该条件下的长度最小的子数组。

示例 2:

输入:target = 4, nums = 1,4,4

输出:1

示例 3:

输入:target = 11, nums = 1,1,1,1,1,1,1,1

输出:0

提示:

1 <= target <= 109

1 <= nums.length <= 105

1 <= numsi <= 104

进阶:

如果你已经实现O(n)时间复杂度的解法, 请尝试设计一个O(n log(n))时间复杂度的解法。

2、解题

方法一:(暴力请求法)

以每一个元素作为起点,找到从这个位置开始往后需要多少位累加才能超过目标值。记录其中包含元数最小的结果值。

复杂度分析:

时间复杂度:O(n^2)。

空间复杂度:O(1)。

代码示例:

java 复制代码
public static int minSubArrayLen(int s, int[] nums) {
        int n = nums.length;
        if (n == 0) {
            return 0;
        }
        int ans = Integer.MAX_VALUE;
        for (int i = 0; i < n; i++) {
            int sum = 0;
            for (int j = i; j < n; j++) {
                sum += nums[j];
                if (sum >= s) {
                    ans = Math.min(ans, j - i + 1);
                    break;
                }
            }
        }
        return ans == Integer.MAX_VALUE ? 0 : ans;
    }

方法二:(左右指针法)

定义左指针和右指针,起始都指向第一个元素。当小于目标值时,右指针持续右移直到大于目标,记录此时的和左指针的间隔。之后在左指针持续左移,直到累加和小于目标值。之后在重复右移...,直到右指针达到末尾结束。

这样做因为左右指针都只要遍历一次数组,时间复杂度上会得到明显提升。

复杂度分析:

时间复杂度:O(n)。 实际为2n,但是在算时间复杂度时,常熟可以去掉,所以是O(n)。

空间复杂度:O(1)。

代码示例:

java 复制代码
    // 左右指针法,连续空间问题求解
    public static int minSubArrayLen(int target, int[] nums) {
        if (nums.length < 0) {
            return 0;
        }
        // 返回结果
        int result = Integer.MAX_VALUE;

        // 数组长度
        int len = nums.length;
        // 左指针
        int left = 0;
        // 右指针
        int right = 0;
        // 连续空间的总值
        int tempSum = nums[0];
        while (left <= right && right < len) {
            if (tempSum >= target) {
                // 总值和大于目标,左指针右移
                result = Math.min(result, (right - left + 1));
                tempSum = tempSum - nums[left];
                left++;
            } else {
                // 总值和小于目标,右指针右移
                right++;
                if (right < len) {
                    tempSum = tempSum + nums[right];
                }
            }
        }
        return result == Integer.MAX_VALUE ? 0 : result;
    }

向阳出发,Dare To Be!!!

相关推荐
飘尘1 小时前
从"算子"到"AI Infra":大模型背后看不见的那群人在忙什么
人工智能·算法·面试
mokongJ2 小时前
17 份异构销售数据的合并清洗方案:30 万行处理耗时 9.64 秒
数据结构
夏幻灵2 小时前
每日一题:LeetCode 3:无重复字符的最长子串——滑动窗口思路详解
算法·leetcode·职场和发展
CarIise2 小时前
Java实训阶段查漏补缺复习笔记2
java·linux·算法
无忧.芙桃2 小时前
C++ 并查集详解:原理、实现与应用
c语言·c++·算法·leetcode
蛋蛋的就会顺顺的2 小时前
hot100——二叉树
java·数据结构·算法·leetcode·力扣
Code_Solitude3 小时前
c语言:二分法的完整补充
c语言·开发语言·算法
一切皆是因缘际会3 小时前
掌控信息论:同源星际通信基础理论
人工智能·算法·ai
List<String> error_P5 小时前
freertos数据结构--链表
数据结构·链表
动词ing5 小时前
【C语言题目练习】算法 整数反转
c语言·开发语言·算法